package com.mycompany;

import javax.ejb.EJBContext;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.SQLException;

public class MyOperationsBean implements MyOperationsBusiness, SessionBean {

    private EJBContext context;

    public void testMyTransactionScope() throws RemoteException {
        System.out.println("testMyTransactionScope(..) called");

        YourOperationsService yourOperationsService = null;
        try {
            // Fetch a connection
            Connection myConnection = Utils.getDataSource().getConnection();

            // Suspend current tx and start a new tx
            final NewTxOperationsHome newTxOperationsHome = Utils.getNewTxOperationsHome();
            final NewTxOperations newTxOperations = newTxOperationsHome.create();
            newTxOperations.testNewTxTransactionScope();

            // Resuming suspended tx and use previously fetched connection to insert a row
            Utils.doInsert(myConnection, "XA_TEST_MY");

            // Call another EJB (propagate tx)
            yourOperationsService = new YourOperationsServiceImpl();
            yourOperationsService.testYourTransactionScope();

            // Do an SQL insert with a freshly fetched connection
            Utils.doInsert(Utils.getDataSource(), "XA_TEST_MY");

            throw new RemoteException("Exception thrown on purpose!");
        } catch (RemoteException e) {
            throw e;
        } catch (Throwable t) {
            throw new RemoteException("Failed to insert data", t);
        } finally {
            if (yourOperationsService != null) {
                try {
                    yourOperationsService.close();
                } catch (SQLException e) {
                    e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
                }
            }
        }
    }

    public void setSessionContext(SessionContext sessionContext) throws EJBException, RemoteException {
        this.context = sessionContext;
    }

    public void ejbRemove() throws EJBException, RemoteException {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void ejbActivate() throws EJBException, RemoteException {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void ejbPassivate() throws EJBException, RemoteException {
        //To change body of implemented methods use File | Settings | File Templates.
    }
}
