package com.mycompany;

import javax.ejb.EJBContext;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.lang.reflect.Field;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.SQLException;

public class YourOperationsBean implements YourOperationsBusiness, SessionBean {

    private EJBContext context;

    public void testYourTransactionScope() throws EJBException {
        testYourTransactionScopeDelegate();
    }

    public void testYourTransactionScopeDelegate() throws EJBException {
        System.out.println("testYourTransactionScope(..) called");

        try {
            // Fetch a connection
            Connection myConnection = Utils.getDataSource().getConnection();

            // Suspend current tx and start a new tx
            final NewTxOperationsHome newTxOperationsHome = Utils.getNewTxOperationsHome();
            final NewTxOperations newTxOperations = newTxOperationsHome.create();
            newTxOperations.testNewTxTransactionScope();

            // Resuming suspended tx and insert SQL using the previously fetched connection
            Utils.doInsert(myConnection, "XA_TEST_OTHER");
        } catch (Exception e) {
            throw new EJBException("Failed to insert data", e);
        }
    }

    public void setSessionContext(SessionContext sessionContext) throws EJBException, RemoteException {
        this.context = sessionContext;
    }

    public void ejbRemove() throws EJBException, RemoteException {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void ejbActivate() throws EJBException, RemoteException {
        //To change body of implemented methods use File | Settings | File Templates.
    }

    public void ejbPassivate() throws EJBException, RemoteException {
        //To change body of implemented methods use File | Settings | File Templates.
    }
}
